
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Outbound_messagesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const outbound_messages = await db.outbound_messages.create(
            {
                id: data.id || undefined,
        
        channel: data.channel
        ||
        null
            ,
            
        subject: data.subject
        ||
        null
            ,
            
        body: data.body
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        scheduled_at: data.scheduled_at
        ||
        null
            ,
            
        sent_at: data.sent_at
        ||
        null
            ,
            
        provider_message_key: data.provider_message_key
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await outbound_messages.setUser( data.user || null, {
            transaction,
        });
        
        await outbound_messages.setContact( data.contact || null, {
            transaction,
        });
        
        await outbound_messages.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return outbound_messages;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const outbound_messagesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                channel: item.channel
            ||
            null
            ,
            
                subject: item.subject
            ||
            null
            ,
            
                body: item.body
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                scheduled_at: item.scheduled_at
            ||
            null
            ,
            
                sent_at: item.sent_at
            ||
            null
            ,
            
                provider_message_key: item.provider_message_key
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const outbound_messages = await db.outbound_messages.bulkCreate(outbound_messagesData, { transaction });

        // For each item created, replace relation files
        

        return outbound_messages;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const outbound_messages = await db.outbound_messages.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.channel !== undefined) updatePayload.channel = data.channel;
        
        
        if (data.subject !== undefined) updatePayload.subject = data.subject;
        
        
        if (data.body !== undefined) updatePayload.body = data.body;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.scheduled_at !== undefined) updatePayload.scheduled_at = data.scheduled_at;
        
        
        if (data.sent_at !== undefined) updatePayload.sent_at = data.sent_at;
        
        
        if (data.provider_message_key !== undefined) updatePayload.provider_message_key = data.provider_message_key;
        
        
        updatePayload.updatedById = currentUser.id;

        await outbound_messages.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await outbound_messages.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.contact !== undefined) {
            await outbound_messages.setContact(
              
              data.contact,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await outbound_messages.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return outbound_messages;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const outbound_messages = await db.outbound_messages.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of outbound_messages) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of outbound_messages) {
                await record.destroy({transaction});
            }
        });


        return outbound_messages;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const outbound_messages = await db.outbound_messages.findByPk(id, options);

        await outbound_messages.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await outbound_messages.destroy({
            transaction
        });

        return outbound_messages;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const outbound_messages = await db.outbound_messages.findOne(
            { where },
            { transaction },
        );

        if (!outbound_messages) {
            return outbound_messages;
        }

        const output = outbound_messages.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await outbound_messages.getUser({
            transaction
        });
        
        
        output.contact = await outbound_messages.getContact({
            transaction
        });
        
        
        output.organizations = await outbound_messages.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.contacts,
        as: 'contact',
        
        where: filter.contact ? {
          [Op.or]: [
            { id: { [Op.in]: filter.contact.split('|').map(term => Utils.uuid(term)) } },
            {
              display_name: {
                [Op.or]: filter.contact.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.subject) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'outbound_messages',
                        'subject',
                        filter.subject,
                    ),
                };
            }
            
            if (filter.body) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'outbound_messages',
                        'body',
                        filter.body,
                    ),
                };
            }
            
            if (filter.provider_message_key) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'outbound_messages',
                        'provider_message_key',
                        filter.provider_message_key,
                    ),
                };
            }
            

            
            

            
            if (filter.scheduled_atRange) {
                const [start, end] = filter.scheduled_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    scheduled_at: {
                    ...where.scheduled_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    scheduled_at: {
                    ...where.scheduled_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.sent_atRange) {
                const [start, end] = filter.sent_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.channel) {
                where = {
                    ...where,
                channel: filter.channel,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.outbound_messages.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'outbound_messages',
                        'subject',
                        query,
                    ),
                ],
            };
        }

        const records = await db.outbound_messages.findAll({
            attributes: [ 'id', 'subject' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['subject', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.subject,
        }));
    }

    
};

